import numpy as np
import casadi as ca


a = np.array([75.0, 125.0, 100.0])
m = 3

b = np.array([80.0, 65.0, 70.0, 85.0])
n = 4

C = np.array([
        [63.0, 15.0, 32.0, 31.0],
        [71.0, 38.0, 60.0, 40.0],
        [34.0, 25.0, 17.0, 42.0]
    ])

X = ca.MX.sym("X", m, n)

f = 0

for i in range(m):

    for j in range(n):

        f += C[i,j] * X[i,j]


g = []
g_min = []
g_max = []


for i in range(m):

    e = 0

    for j in range(n):

        e += X[i,j]

    g.append(e)
    g_min.append(a[i])
    g_max.append(a[i])


for j in range(n):

    e = 0

    for i in range(m):

        e += X[i,j]

    g.append(e)
    g_min.append(b[j])
    g_max.append(b[j])


g = ca.vertcat(*g)
X = ca.vec(X)

lp = {"x": X, "f": f, "g": g}

solver = ca.nlpsol("solver", "ipopt", lp)

X_init = np.zeros(X.shape)
X_min = np.zeros(X.shape)
X_max = np.inf * np.ones(X.shape)

solution = solver(x0 = X_init, lbx = X_min, ubx = X_max, \
    lbg = g_min, ubg = g_max)

K_opt = solution["f"]
X_opt = ca.reshape(solution["x"], 3, 4)

print "\nTransportation cost:\n\n" + str(K_opt)
print "\nTransportation matrix:\n" + str(X_opt)
